// SM64 object patch in assembly
// use armips on 64MB extended ROM to apply

.n64
.open "sm64.ext.z64", "sm64.1.patched.z64", 0x80245000

// -----------------------------------------------------------------------------
// Existing functions
// -----------------------------------------------------------------------------
.org 0x80278504
DmaCopy:
.org 0x8027868C
DynamicIndexCopy:
.org 0x80318040
BlockDmaCopy:

// -----------------------------------------------------------------------------
// NOP out checksum infinite loop
// -----------------------------------------------------------------------------
.orga 0x66C
nop             // 00066C 14E80006  bne   a3, t0, 0x688
nop             // 000670 00000000  nop
lw t0, 0x14(t3) // 000674 8D680014  lw    t0, 0x14(t3)
nop             // 000678 16080003  bne   s0, t0, 0x688

// -----------------------------------------------------------------------------
// overwrite unnecessary branch with jal to unused Behavior12 function
// -----------------------------------------------------------------------------
// 802789FC: b .L80278A04
.org 0x802789FC
jal InitExpansionRam // Behavior12 / 0x80384E04

// -----------------------------------------------------------------------------
// replace reference to sequence bank
// -----------------------------------------------------------------------------
.org 0x80319714
lui   a0, 0x2F0  // 0D4714 80319714 3C04007B  lui   a0, 0x7b
sw    a1, (v0)   // 0D4718 80319718 AC450000  sw    a1, (v0)
addiu a0, a0, 0  // 0D471C 8031971C 24840860  addiu a0, a0, 0x860

.org 0x80319768
lui   a0, 0x2F0 // 0D4768 80319768 3C04007B  lui   a0, 0x7b
sw    v0, (v1)  // 0D476C 8031976C AC620000  sw    v0, (v1)
addiu a0, a0, 0 // 0D4770 80319770 24840860  addiu a0, a0, 0x860

.org 0x80319784
lui   a1, 0x2F0 // 0D4784 80319784 3C05007B  lui   a1, 0x7b
addiu a1, a1, 0 // 0D4788 80319788 24A50860  addiu a1, a1, 0x860

// -----------------------------------------------------------------------------
// update reference to instrument set table and increase size
// -----------------------------------------------------------------------------
.org  0x803198C4
lui   a0, 0x7F        // 0D48C4 803198C4 3C04007D  lui   a0, 0x7d
sw    v0, (v1)        // 0D48C8 803198C8 AC620000  sw    v0, (v1)
ori   a0, a0, 0       // 0D48CC 803198CC 2484C620  addiu a0, a0, -0x39e0
or    a1, v0, zero    // 0D48D0 803198D0 00402825  move  a1, v0
jal   BlockDmaCopy    // 0D48D4 803198D4 0C0C6010  jal   BlockDmaCopy
addiu a2, zero, 0x200 // 0D48D8 803198D8 24060100  addiu a2, zero, 0x100

// -----------------------------------------------------------------------------
// slight change to whomp's star spawn
// -----------------------------------------------------------------------------
// TODO: this probably shouldn't exist
.orga  0x0f2dd0
.float 3872.0 // 3880.0

.headersize 0x80283280

// -----------------------------------------------------------------------------
// collision triangles: replace LevelScript1E pool_alloc() with 0x80750000/0x80670000
// -----------------------------------------------------------------------------
.org 0x80383348
addiu t6, zero, 0x4000 // 1000C8 80383348 240E08FC  addiu t6, zero, 0x8fc
lui   at, 0x8039       // 1000CC 8038334C 3C018039  lui   at, 0x8039
sh    t6, -0x1160(at)  // 1000D0 80383350 A42EEEA0  sh    t6, %lo(0x8038EEA0)(at)
ori   a0, zero, 0xDAC0 // 1000D4 80383354 3404DAC0  ori   a0, zero, 0xdac0
lui   v0, 0x8075       // 1000D8 80383358 0C09E048  jal   _pool_alloc / 80278120
nop                    // 1000DC 8038335C 00002825  move  a1, zero

.org 0x80383380
lui   v0, 0x8067       // 100100 80383380 0C09E048  jal   _pool_alloc
ori   v0, v0, 0        // 100104 80383384 01E02025  move  a0, t7

// -----------------------------------------------------------------------------
// replace unused Behavior12 function
// -----------------------------------------------------------------------------
.org 0x80384E04
InitExpansionRam: // Behavior12:
  addiu sp, sp, -0x18  // 101B84 80384E04 27BDFFF8  addiu sp, sp, -8
  sw    ra, 0x14(sp)   // 101B88 80384E08 3C0E8036  lui   t6, 0x8036
  lui   a0, 0x8040     // 101B8C 80384E0C 8DCE1164  lw    t6, 0x1164(t6)
  lui   a1, 0x807f     // 101B90 80384E10 8DCF0000  lw    t7, (t6)
  ori   a1, a1, 0xfffc // 101B94 80384E14 000FC402  srl   t8, t7, 0x10
@@loop:
  sw    zero, (a0)     // 101B98 80384E18 331900FF  andi  t9, t8, 0xff
  addiu a0, a0, 4      // 101B9C 80384E1C A3B90007  sb    t9, 7(sp)
  bne   a1, a0, @@loop // 101BA0 80384E20 3C088036  lui   t0, 0x8036
  addiu zero, zero, 0  // 101BA4 80384E24 8D081164  lw    t0, 0x1164(t0)
  lui   a0, 0x8040     // 101BA8 80384E28 8D090000  lw    t1, (t0)
  ori   a0, a0, 0      // 101BAC 80384E2C 312AFFFF  andi  t2, t1, 0xffff
  lui   a1, 0x120      // 101BB0 80384E30 000A5C00  sll   t3, t2, 0x10
  ori   a1, a1, 0      // 101BB4 80384E34 000B6403  sra   t4, t3, 0x10
  lui   a2, 0x130      // 101BB8 80384E38 AFAC0000  sw    t4, (sp)
  jal   DmaCopy        // 101BBC 80384E3C 8FAD0000  lw    t5, (sp)
  ori   a2, a2, 0      // 101BC0 80384E40 31AEFFFF  andi  t6, t5, 0xffff
  lw    ra, 0x14(sp)   // 101BC4 80384E44 39CFFFFF  xori  t7, t6, 0xffff
  jr    ra             // 101BC8 80384E48 AFAF0000  sw    t7, (sp)
  addiu sp, sp, 0x18   // 101BCC 80384E4C 93B90007  lbu   t9, 7(sp)

// -----------------------------------------------------------------------------
// replace level script 0x10 and 0x17 function pointers
// -----------------------------------------------------------------------------
.orga 0x108678
.dw ExtLevelScript17
.orga 0x108694
.dw ExtLevelScript17

// -----------------------------------------------------------------------------
// TODO: something near end of old sequence bank
// -----------------------------------------------------------------------------
.orga 0x7B085C
.dw 0x00000011

// -----------------------------------------------------------------------------
// relocate sequence bank
// -----------------------------------------------------------------------------
.orga 0x7F0000
.dh 0x006a, 0x0076, 0x0078, 0x007a, 0x007c, 0x007e, 0x0080, 0x0082
.dh 0x0084, 0x0086, 0x0088, 0x008b, 0x008d, 0x008f, 0x0091, 0x0093
.dh 0x0095, 0x0097, 0x0099, 0x009b, 0x009d, 0x009f, 0x00a1, 0x00a3
.dh 0x00a5, 0x00a7, 0x00a9, 0x00ab, 0x00ad, 0x00af, 0x00b1, 0x00b3
.dh 0x00b5, 0x00b7, 0x00b9, 0x00bb, 0x00bd, 0x00bf, 0x00c1, 0x00c3
.dh 0x00c5, 0x00c7, 0x00c9, 0x00cb, 0x00cd, 0x00cf, 0x00d1, 0x00d3
.dh 0x00d5, 0x00d7, 0x00d9, 0x00db, 0x00dd, 0x0b0a, 0x0908, 0x0706
.dh 0x0504, 0x0302, 0x0100, 0x0122, 0x0111, 0x0122, 0x010e, 0x0113
.dh 0x010f, 0x0112, 0x010b, 0x010d, 0x0221, 0x1001, 0x1401, 0x1501
.dh 0x1601, 0x1701, 0x1801, 0x1201, 0x1901, 0x1f01, 0x2101, 0x1a01
.dh 0x0e01, 0x1b01, 0x1a01, 0x1c01, 0x1d01, 0x2501, 0x1401, 0x2001
.dh 0x1e01, 0x1b01, 0x1a01, 0x2301, 0x2401, 0x1b01, 0x1101, 0x1101
.dh 0x1101, 0x1101, 0x1101, 0x1101, 0x1101, 0x1101, 0x1101, 0x1101
.dh 0x1101, 0x1101, 0x1101, 0x1101, 0x1101, 0x1101, 0x1101, 0x11ff

// -----------------------------------------------------------------------------
// list music track titles - length is first byte
// -----------------------------------------------------------------------------
.orga 0x7F1000
name00:
.db (name01 - name00 - 1), "00 - No music"
name01:
.db (name02 - name01 - 1), "01 - End level"
name02:
.db (name03 - name02 - 1), "02 - SMB (Title Screen)"
name03:
.db (name04 - name03 - 1), "03 - Bob-omb's Battlefield"
name04:
.db (name05 - name04 - 1), "04 - Inside Castle walls"
name05:
.db (name06 - name05 - 1), "05 - Dire Dire Docks"
name06:
.db (name07 - name06 - 1), "06 - Lethal Laval land"
name07:
.db (name08 - name07 - 1), "07 - Bowser battle"
name08:
.db (name09 - name08 - 1), "08 - Snow"
name09:
.db (name10 - name09 - 1), "09 - Slide"
name10:
.db (name11 - name10 - 1), "10 - Haunted House"
name11:
.db (name12 - name11 - 1), "11 - Piranha plant lullaby"
name12:
.db (name13 - name12 - 1), "12 - Hazy Maze"
name13:
.db (name14 - name13 - 1), "13 - Star select"
name14:
.db (name15 - name14 - 1), "14 - Wing cap"
name15:
.db (name16 - name15 - 1), "15 - Metal cap"
name16:
.db (name17 - name16 - 1), "16 - Bowser Message"
name17:
.db (name18 - name17 - 1), "17 - Bowser course"
name18:
.db (name19 - name18 - 1), "18 - Star catch"
name19:
.db (name20 - name19 - 1), "19 - Ghost Merry-go-round"
name20:
.db (name21 - name20 - 1), "20 - Start and End Race with Koopa the Quick"
name21:
.db (name22 - name21 - 1), "21 - Star appears"
name22:
.db (name23 - name22 - 1), "22 - Boss fight"
name23:
.db (name24 - name23 - 1), "23 - Take a Key"
name24:
.db (name25 - name24 - 1), "24 - Looping stairs"
name25:
.db (name26 - name25 - 1), "25 - Bowser Fight"
name26:
.db (name27 - name26 - 1), "26 - Credits song"
name27:
.db (name28 - name27 - 1), "27 - 1-up"
name28:
.db (name29 - name28 - 1), "28 - Toad"
name29:
.db (name30 - name29 - 1), "29 - Peach message"
name30:
.db (name31 - name30 - 1), "30 - Intro Castle sequence"
name31:
.db (name32 - name31 - 1), "31 - End fanfare"
name32:
.db (name33 - name32 - 1), "32 - End music"
name33:
.db (name34 - name33 - 1), "33 - Menu"
name34:
.db (name35 - name34 - 1), "34 - Lakitu"
name35:
.db (name36 - name35 - 1), "35 - Custom Music 1"
name36:
.db (name37 - name36 - 1), "36 - Custom Music 2"
name37:
.db (name38 - name37 - 1), "37 - Custom Music 3"
name38:
.db (name39 - name38 - 1), "38 - Custom Music 4"
name39:
.db (name40 - name39 - 1), "39 - Custom Music 5"
name40:
.db (name41 - name40 - 1), "40 - Custom Music 6"
name41:
.db (name42 - name41 - 1), "41 - Custom Music 7"
name42:
.db (name43 - name42 - 1), "42 - Custom Music 8"
name43:
.db (name44 - name43 - 1), "43 - Custom Music 9"
name44:
.db (name45 - name44 - 1), "44 - Custom Music 10"
name45:
.db (name46 - name45 - 1), "45 - Custom Music 11"
name46:
.db (name47 - name46 - 1), "46 - Custom Music 12"
name47:
.db (name48 - name47 - 1), "47 - Custom Music 13"
name48:
.db (name49 - name48 - 1), "48 - Custom Music 14"
name49:
.db (name50 - name49 - 1), "49 - Custom Music 15"
name50:
.db (name51 - name50 - 1), "50 - Custom Music 16"
name51:
.db (name52 - name51 - 1), "51 - Custom Music 17"
name52:
.db (name53 - name52 - 1), "52 - Custom Music 18"
name53:
.db (name99 - name53 - 1), "53 - Custom Music 19"
name99:

// -----------------------------------------------------------------------------
// TODO: some level script?
// -----------------------------------------------------------------------------
.orga 0x011fff00
.dw 0x0010000e, 0x01200000, 0x012011b0, 0x0e0000d0

// -----------------------------------------------------------------------------
// TODO: more level script and geo layout?
// -----------------------------------------------------------------------------
.orga 0x01200000
.include "empty_level.asm"

.headersize 0x7F200000
// -----------------------------------------------------------------------------
// replacement level script 0x10 and 0x17 function
// -----------------------------------------------------------------------------
.org 0x80401500
ExtLevelScript17:
  addiu sp, sp, -0x30
  sw    ra, 0x2c(sp)
  sw    fp, 0x28(sp)
  move  fp, sp
  lui   gp, 0x8040
  addiu gp, gp, 0x1600
  lui   v0, 0x8038
  ori   v0, v0, 0xbe28
  sw    v0, 0x18(fp)
  lui   v0, 0x8038
  ori   v0, v0, 0xbe28
  sw    v0, 0x14(fp)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lbu   v1, 2(v0)
  addiu v0, zero, 1
  bne   v1, v0, @@zero
  nop
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v1, 4(v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v0, 8(v0)
  lui   a0, 0x8050
  move  a1, v1
  jal   DmaCopy // 0x80278504
  move  a2, v0
  lui   v0, 0x8033
  ori   v0, v0, 0xb41c
  sw    v0, 0x10(fp)
  lw    v1, 0x10(fp)
  lui   v0, 0x50
  j     @@notzero
  sw    v0, (v1)
@@zero:
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lbu   v0, 3(v0)
  move  a0, v0
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v1, 4(v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lw    v0, 8(v0)
  move  a1, v1
  move  a2, v0
  jal   DynamicIndexCopy // 0x8027868C
  move  a3, zero
@@notzero:
  lw    v0, 0x14(fp)
  lw    v1, (v0)
  lw    v0, 0x18(fp)
  lw    v0, (v0)
  lbu   v0, 1(v0)
  addu  v1, v1, v0
  lw    v0, 0x14(fp)
  sw    v1, (v0)
  move  sp, fp
  lw    ra, 0x2c(sp)
  lw    fp, 0x28(sp)
  jr    ra
  addiu sp, sp, 0x30
// TODO: what is this?
.dw 0xAAAAAAAA, 0xAAAAAAAA

// -----------------------------------------------------------------------------
// TODO: water related?
// -----------------------------------------------------------------------------
.org 0x80403000
.dw 0x20000000, 0x20000000, 0x00000000, 0x000000FF
.dw 0xDFFF0000, 0xDFFF0000, 0x50DE50DE, 0x000000FF
.dw 0xDFFF0000, 0x20000000, 0x000050DE, 0x000000FF
.dw 0x20000000, 0xDFFF0000, 0x50DE0000, 0x000000FF
.dw 0xE7000000, 0x00000000, 0xB7000000, 0x00000000
.dw 0xFC127FFF, 0xFFFFF838, 0xF5100000, 0x07000000
.dw 0xBB000001, 0xFFFFFFFF, 0xE8000000, 0x00000000
.dw 0xF5101000, 0x00014050, 0xF2000000, 0x0000C07C
.dw 0xFD100000, 0x09005800, 0xE6000000, 0x00000000
.dw 0xF3000000, 0x073FF100, 0x03860010, 0x070000D0
.dw 0x03880010, 0x070000D4, 0x04300000, 0x07000000
.dw 0xBF000000, 0x00000A14, 0xBF000000, 0x00001E0A
.dw 0xBB000000, 0xFFFFFFFF, 0xB8000000, 0x00000000
.dw 0xFFFFFFFF, 0xA0A0A0FF, 0x00400004, 0x20000000
.dw 0x2000DFFF, 0x0000DFFF, 0xDFFF0000, 0x20002000
.dw 0x0000DFFF, 0x00000002, 0x00000001, 0x00020000
.dw 0x00030001, 0x00410042

// -----------------------------------------------------------------------------
// TODO: BK textures and F3D do not belong
// -----------------------------------------------------------------------------
.orga 0x01210000
.incbin "bin/1210000.bk_textures.bin"
.incbin "bin/1237800.bk_f3d.bin"
.incbin "bin/125C4F0.bk_textures.bin"
.incbin "bin/12674F0.bk_data.bin"

// -----------------------------------------------------------------------------
// TODO: BK textures and F3D do not belong
// -----------------------------------------------------------------------------
.orga 0x012F0000
.incbin "bin/1210000.bk_textures.bin"
.incbin "bin/1237800.bk_f3d.bin"
.incbin "bin/125C4F0.bk_textures.bin"
.incbin "bin/12674F0.bk_data.bin"

// -----------------------------------------------------------------------------
// empty level data
// -----------------------------------------------------------------------------
.orga 0x12E0000
.include "empty_level.asm"
.orga 0x1360000
.include "empty_level.asm"
.orga 0x13C0000
.include "empty_level.asm"
.orga 0x014A0000
.include "empty_level.asm"
.orga 0x014C0000
.include "empty_level.asm"
.orga 0x01580000
.include "empty_level.asm"
.orga 0x01620000
.include "empty_level.asm"
.orga 0x01660000
.include "empty_level.asm"
.orga 0x01740000
.include "empty_level.asm"
.orga 0x01780000
.include "empty_level.asm"
.orga 0x01820000
.include "empty_level.asm"
.orga 0x018E0000
.include "empty_level.asm"
.orga 0x01900000
.include "empty_level.asm"
.orga 0x019E0000
.include "empty_level.asm"
.orga 0x01A40000
.include "empty_level.asm"
.orga 0x01AC0000
.include "empty_level.asm"
.orga 0x01BA0000
.include "empty_level.asm"
.orga 0x01C80000
.include "empty_level.asm"
.orga 0x01D00000
.include "empty_level.asm"
.orga 0x01D60000
.include "empty_level.asm"
.orga 0x01E40000
.include "empty_level.asm"
.orga 0x01E60000
.include "empty_level.asm"
.orga 0x01F20000
.include "empty_level.asm"
.orga 0x01FC0000
.include "empty_level.asm"
.orga 0x02000000
.include "empty_level.asm"
.orga 0x020E0000
.include "empty_level.asm"
.orga 0x02120000
.include "empty_level.asm"
.orga 0x021C0000
.include "empty_level.asm"
.orga 0x02280000
.include "empty_level.asm"
.orga 0x022A0000
.include "empty_level.asm"
.orga 0x02380000
.include "empty_level.asm"
.orga 0x023E0000
.include "empty_level.asm"
.orga 0x02460000
.include "empty_level.asm"
.orga 0x02540000
.include "empty_level.asm"
.orga 0x02620000
.include "empty_level.asm"
.orga 0x026A0000
.include "empty_level.asm"
.orga 0x02700000
.include "empty_level.asm"
.orga 0x027E0000
.include "empty_level.asm"
.orga 0x02800000
.include "empty_level.asm"
.orga 0x028C0000
.include "empty_level.asm"
.orga 0x02960000
.include "empty_level.asm"
.orga 0x029A0000
.include "empty_level.asm"
.orga 0x02A80000
.include "empty_level.asm"
.orga 0x02AC0000
.include "empty_level.asm"
.orga 0x02B60000
.include "empty_level.asm"
.orga 0x02C20000
.include "empty_level.asm"
.orga 0x02C40000
.include "empty_level.asm"
.orga 0x02D20000
.include "empty_level.asm"
.orga 0x02D80000
.include "empty_level.asm"
.orga 0x02EE0000
.include "empty_level.asm"

// -----------------------------------------------------------------------------
// music data
// -----------------------------------------------------------------------------
.orga 0x02F00000
.incbin "bin/2F00000.music_data.bin"

// -----------------------------------------------------------------------------
// empty level data
// -----------------------------------------------------------------------------
.orga 0x03040000
.include "empty_level.asm"
.orga 0x031A0000
.include "empty_level.asm"
.orga 0x03300000
.include "empty_level.asm"
.orga 0x03460000
.include "empty_level.asm"
.orga 0x035C0000
.include "empty_level.asm"
.orga 0x03720000
.include "empty_level.asm"
.orga 0x03880000
.include "empty_level.asm"
.orga 0x039E0000
.include "empty_level.asm"
.orga 0x03B40000
.include "empty_level.asm"

.close
